
#include "common.h" 
#include "threeDee.h"

/* Creating a test pyramid the hard way. */
struct point pyramidPoints[5] = 
    {
       { -10, -10, 0},
       {-10, 10, 0},
       {10, 10, 0},
       {10 -10, 0},
       {0, 0, 10},
    };

int pts1[] = {0, 1, 4};
struct polygon side1 =
    {
    NULL,
    3, pts1,
    };
int pts2[] = {1, 2, 4};
struct polygon side2 =
    {
    &side1,
    3, pts2,
    };
int pts3[] = {2, 3, 4};
struct polygon side3 =
    {
    &side2,
    3, pts3,
    };
int pts4[] = {3, 0, 4};
struct polygon side4 =
    {
    &side3,
    3, pts4,
    };
int ptsBase[] = {0,1,2,3};
struct polygon base =
    {
    &side4,
    4, ptsBase,
    };

struct polyhedron pyramid =
    {
    NULL,
    "pyramid",
    5, &base,
    4, pyramidPoints,
    };

void usage()
/* Print usage instructions and exit. */
{
errAbort("test3d - write a pyramid to a file and read it back in.\n"
         "usage:\n"
	 "    test3d fileName");
}

void test3d(char *fileName)
/* Write pyramid to file and read it back in.  Let user see it. */
{
FILE *f;
struct polyhedron *p;

/* Write it to standard output. */
printf("Test pyramid:\n");
polyhedronTabOut(&pyramid, stdout);

/* Write it to file. */
printf("Writing to %s\n", fileName);
f = mustOpen(fileName, "w");
polyhedronTabOut(&pyramid, f);
fclose(f);

/* Read it back in from file. */
printf("Reading back from %s\n", fileName);
p = polyhedronLoadAll(fileName);

/* Write it back out to stdout. */
printf("It comes back as:\n");
polyhedronTabOut(p, stdout);

printf("Freeing it back up\n");
polyhedronFreeList(&p);
}

int main(int argc, char *argv[])
/* Parse command line and print usage. */
{
if (argc != 2)
   usage();
test3d(argv[1]); 
return 0;
}
